import processing.bluetooth.*;

import processing.phone.*;


Bluetooth bt;
Client c;
Service[] services;
String msg = "";

final int STATE_MENU = 0;
final int STATE_HOSTING = 1;
final int STATE_CLIENT = 2;
final int STATE_PLAYING = 3;
final int STATE_BALL_LOST = 4;
final int STATE_BALL_SCORED = 5;
final int STATE_SINGLEPLAY = 6;

int  BOOST = 0;
int state;
int YOUR_SIDE;
int YOUR_POINTS = 0;
int OPPONENT_POINTS = 0;

Phone phone;


int[] racketPos = {
  0,200}; 
int[] racketNextPos = {0, 200};
int[] racketVel = {
  0,0};
int racketGrav = 12;
int[] racketAcc = {
  0,racketGrav};
int racketWidth = 70;
int racketHeight = 20;
int racketMaxHeight;

int[] ballPos = {
  0,0};
int[] ballNextPos = {0, 200};
int[] ballVel = {
  0,0};
int ballGrav = 9;
int[] ballAcc = {
  0,ballGrav};
int ballRadius = 10;

int gravityConstant;

PFont font;

void setup()
{
  
  phone = new Phone(this);
  //phone.fullscreen();
  bt = new Bluetooth(this);
  noStroke();
  racketPos[0] = racketNextPos[0] = (width/2)-(racketWidth/2);
  racketPos[1] = racketNextPos[1] = height-racketHeight-20;
  racketWidth = (height/4);
  racketHeight = (height/15);
  racketMaxHeight = (height/2);
  ballRadius =  (height/20);
  ballPos[0] = ballNextPos[0] = (width/2);
  ballPos[1] = ballNextPos[1] = (height/2);
  gravityConstant = div(7000,height);
  framerate(60);
  font = loadFont(FACE_PROPORTIONAL,STYLE_PLAIN,SIZE_SMALL);
  //font = loadFont();
  textFont(font);
  state=STATE_MENU;
}

void destroy() {
  bt.stop();
}

void draw()
{
 background(0);
 
  switch(state) { 
  case STATE_MENU:
    drawStillBall();
    drawStillRacket();
    fill(200);
    textAlign(LEFT);
    text("A small game\n\nTo host a small game press <-\nTo find a small game press ->\nBluetooth must be enabled!\n\nTo play on you own press down", 5, 10,width,height);
    break;
  
  case STATE_HOSTING:
    drawStillBall();
    drawStillRacket();
    fill(200);
    textAlign(LEFT);
    text("Waiting for connection...\n" + msg,(width/3), (height/3),width,height);
    break;    
  
  case STATE_CLIENT:
    drawStillRacket();
    fill(200);
    textAlign(LEFT);
    text("Searching for game...\n" + msg, (width/3), (height/3),width,height);
    break;    

  case STATE_PLAYING:
   calcNextRacketPos();
   calcRacketCollisions();
   drawRacket();
   
   if(YOUR_SIDE==1)
    {
     calcNextBallPos();
     calcBallCollisions();
     drawBall();

    }
   else
   {
    fill(200);
    textAlign(LEFT);
    text("Waiting for ball.",(width/3), (height/3),width,height);
      if (c.available() > 0) 
       {
         ballVel[0] = c.readInt();
         ballVel[1] = c.readInt();
         ballAcc[0] = c.readInt();
         ballAcc[1] = c.readInt();
         ballPos[0] = c.readInt();
         ballPos[0] = mul(ballPos[0],width);
         println(ballPos[0]);
         ballPos[1] = c.readInt();
         ballPos[1] = 0;
         int flag = c.readInt();
         YOUR_SIDE = 1;
         
         if(flag==1) 
         {
              state = STATE_BALL_SCORED;
              YOUR_SIDE = 1;
              YOUR_POINTS++;
              ballPos[0] = (width/2);
              ballPos[1] = (height/2);
              ballVel[0] = 0;
              ballVel[1] = 0;
              ballAcc[0] = 0;
              ballAcc[1] = 0;
         }
       }
     
     }
   break;
  
  case STATE_BALL_SCORED:
    drawRacket();
    calcRacketCollisions(); 
    drawStillBall();
    fill(200);
    textAlign(LEFT);
    text("You scored!\nPress down to drop ball\n" + YOUR_POINTS + "   " + OPPONENT_POINTS,(width/3), (height/3),width,height);
    break; 
    
  case STATE_BALL_LOST:
    drawRacket();
    calcRacketCollisions();   
    fill(200);
    textAlign(LEFT);
    text("Opponent scored!\n" + YOUR_POINTS + "   " + OPPONENT_POINTS,(width/3), (height/3),width,height);
    if (c.available() > 0) 
     {
       c.readInt();
       state=STATE_PLAYING;
       YOUR_SIDE=0;
     }
    break; 
  
 case STATE_SINGLEPLAY:
   calcNextRacketPos();
   calcRacketCollisions();
   drawRacket();
   calcNextBallPos();
   calcBallCollisions();
   drawBall();
   break;  
  } 
}
