import processing.core.*; import processing.bluetooth.*; import processing.phone.*; public class foofpong extends PMIDlet{




Bluetooth bt;
Client c;
Service[] services;
String msg = "";

final int STATE_MENU = 0;
final int STATE_HOSTING = 1;
final int STATE_CLIENT = 2;
final int STATE_PLAYING = 3;
final int STATE_BALL_LOST = 4;
final int STATE_BALL_SCORED = 5;
final int STATE_SINGLEPLAY = 6;

int  BOOST = 0;
int state;
int YOUR_SIDE;
int YOUR_POINTS = 0;
int OPPONENT_POINTS = 0;

Phone phone;


int[] racketPos = {
  0,200}; 
int[] racketNextPos = {0, 200};
int[] racketVel = {
  0,0};
int racketGrav = 12;
int[] racketAcc = {
  0,racketGrav};
int racketWidth = 70;
int racketHeight = 20;
int racketMaxHeight;

int[] ballPos = {
  0,0};
int[] ballNextPos = {0, 200};
int[] ballVel = {
  0,0};
int ballGrav = 9;
int[] ballAcc = {
  0,ballGrav};
int ballRadius = 10;

int gravityConstant;

PFont font;

public void setup()
{
  
  phone = new Phone(this);
  //phone.fullscreen();
  bt = new Bluetooth(this);
  noStroke();
  racketPos[0] = racketNextPos[0] = (width/2)-(racketWidth/2);
  racketPos[1] = racketNextPos[1] = height-racketHeight-20;
  racketWidth = (height/4);
  racketHeight = (height/15);
  racketMaxHeight = (height/2);
  ballRadius =  (height/20);
  ballPos[0] = ballNextPos[0] = (width/2);
  ballPos[1] = ballNextPos[1] = (height/2);
  gravityConstant = div(7000,height);
  framerate(60);
  font = loadFont(FACE_PROPORTIONAL,STYLE_PLAIN,SIZE_SMALL);
  //font = loadFont();
  textFont(font);
  state=STATE_MENU;
}

public void destroy() {
  bt.stop();
}

public void draw()
{
 background(0);
 
  switch(state) { 
  case STATE_MENU:
    drawStillBall();
    drawStillRacket();
    fill(200);
    textAlign(LEFT);
    text("A small game\n\nTo host a small game press <-\nTo find a small game press ->\nBluetooth must be enabled!\n\nTo play on you own press down", 5, 10,width,height);
    break;
  
  case STATE_HOSTING:
    drawStillBall();
    drawStillRacket();
    fill(200);
    textAlign(LEFT);
    text("Waiting for connection...\n" + msg,5,10,width,height);
    break;    
  
  case STATE_CLIENT:
    drawStillRacket();
    fill(200);
    textAlign(LEFT);
    text("Searching for game...\n" + msg,5,10,width,height);
    break;    

  case STATE_PLAYING:
   calcNextRacketPos();
   calcRacketCollisions();
   drawRacket();
   
   if(YOUR_SIDE==1)
    {
     calcNextBallPos();
     calcBallCollisions();
     drawBall();

    }
   else
   {
    fill(200);
    textAlign(LEFT);
    text("Waiting for ball.",5,10,width,height);
      if (c.available() > 0) 
       {
         ballVel[0] = c.readInt();
         ballVel[1] = c.readInt();
         ballAcc[0] = c.readInt();
         ballAcc[1] = c.readInt();
         ballPos[0] = c.readInt();
         ballPos[0] = mul(ballPos[0],width);
         ballPos[1] = c.readInt();
         ballPos[1] = 0;
         int flag = c.readInt();
         YOUR_SIDE = 1;
         
         if(flag==1) 
         {
              state = STATE_BALL_SCORED;
              YOUR_SIDE = 1;
              YOUR_POINTS++;
              ballPos[0] = (width/2);
              ballPos[1] = (height/2);
              ballVel[0] = 0;
              ballVel[1] = 0;
              ballAcc[0] = 0;
              ballAcc[1] = 0;
         }
       }
     
     }
   break;
  
  case STATE_BALL_SCORED:
   calcNextRacketPos();
   calcRacketCollisions();
   drawRacket();
    drawStillBall();
    fill(200);
    textAlign(LEFT);
    text("You scored!\nPress down to drop ball\n" + YOUR_POINTS + "   " + OPPONENT_POINTS,5,10,width,height);
    break; 
    
  case STATE_BALL_LOST:
    calcNextRacketPos();
    calcRacketCollisions();
    drawRacket();
    calcRacketCollisions();   
    fill(200);
    textAlign(LEFT);
    text("Opponent scored!\n" + YOUR_POINTS + "   " + OPPONENT_POINTS,5,10,width,height);
    if (c.available() > 0) 
     {
       c.readInt();
       state=STATE_PLAYING;
       YOUR_SIDE=0;
     }
    break; 
  
 case STATE_SINGLEPLAY:
   calcNextRacketPos();
   calcRacketCollisions();
   drawRacket();
   calcNextBallPos();
   calcBallCollisions();
   drawBall();
   break;  
  } 
}

public void drawBall()
{
    ballPos[0]=ballNextPos[0];
    ballPos[1]=ballNextPos[1];
    drawStillBall();
}

public void drawStillBall()
{
    fill(100,0,0); 
    ellipse(ballPos[0],ballPos[1],ballRadius+ballRadius,ballRadius+ballRadius);   
}

public void calcNextBallPos()
{
  ballNextPos[1]=ballPos[1]+div(ballVel[1]+=ballAcc[1],gravityConstant);
  ballNextPos[0]=ballPos[0]+div(ballVel[0]+=ballAcc[0],gravityConstant);
}

public void calcBallCollisions()
{
      
  if(ballNextPos[0]+ballRadius>=racketNextPos[0] && ballNextPos[0]<=racketNextPos[0]+racketWidth){
    if(ballNextPos[1]+ballRadius>=racketNextPos[1] && ballNextPos[1]<=racketNextPos[1]+racketHeight){
      ballVel[1]=-(ballVel[1]-racketVel[1]);
      ballVel[0]=-(ballVel[0]-racketVel[0]);
      ballNextPos[1]=racketPos[1]+div(racketVel[1]+racketAcc[1],gravityConstant)-ballRadius;

    }
  } 

    if(ballNextPos[1]<-(2*ballRadius))
    {
     if(state==STATE_SINGLEPLAY)
       {
        ballVel[1]=-(ballVel[1]/2);
        ballNextPos[1]=(ballRadius);
       }
     else if(state==STATE_PLAYING)
      {
       ballVel[1]=-(ballVel[1]/2);
       ballPos[1]=(ballRadius/2);
       ballPos[0]=div(ballPos[0],width);
      YOUR_SIDE = 0;
      c.writeInt(ballVel[0]);
      c.writeInt(ballVel[1]);
      c.writeInt(ballAcc[0]);
      c.writeInt(ballAcc[1]);
      c.writeInt(ballPos[0]);
      c.writeInt(ballPos[1]);
      c.writeInt(0);
      c.flush();
    
      ballVel[0] = 0;
      ballVel[1] = 0;
      ballAcc[0] = 0;
      ballAcc[1] = 0;
      }   
    }
    
    else if(ballNextPos[1]>height+(2*ballRadius))
    {
    if(state==STATE_SINGLEPLAY)
     {
      ballVel[1] = 0; 
      ballNextPos[1]=(ballRadius/2);
     }
    else if(state==STATE_PLAYING)
       {
      c.writeInt(ballVel[0]);
      c.writeInt(ballVel[1]);
      c.writeInt(ballAcc[0]);
      c.writeInt(ballAcc[1]);
      c.writeInt(ballPos[0]);
      c.writeInt(ballPos[1]);
      c.writeInt(1);
      c.flush();
      OPPONENT_POINTS++;
      state=STATE_BALL_LOST;
      }
    }
      
  
  if(ballNextPos[0]+ballRadius>width)
  {
    ballNextPos[0]=width-ballRadius;
    ballVel[0]=-ballVel[0];
    ballVel[0]=(ballVel[0]/2);
  }
  else if(ballNextPos[0]-ballRadius<0)
  {
    ballPos[0]=ballRadius;
    ballVel[0]=-ballVel[0];
    ballVel[0]=(ballVel[0]/2);    
  }

}

public void keyPressed()
{
  switch(keyCode) {
  case LEFT:
    if(state==STATE_PLAYING || state==STATE_BALL_LOST ||state==STATE_BALL_SCORED|| state==STATE_SINGLEPLAY)
      racketAcc[0]=-20;
    else if(state==STATE_MENU)
      {
      state=STATE_HOSTING;
      bt.start("foofpong");
      }
    break;
  case RIGHT:
    if(state==STATE_PLAYING || state==STATE_BALL_LOST || state==STATE_BALL_SCORED|| state==STATE_SINGLEPLAY)
      racketAcc[0]=20;
    else if(state==STATE_MENU)
      {
      state=STATE_CLIENT;
      ballPos[0] = -10;
      ballPos[1] = -10;
      ballAcc[1] = 0;
      bt.find();
      }
    else if(state==STATE_CLIENT)
      {
      if (services != null) {
          for(int i = 0;i<length(services);i++)
            {
            if((services[i].name).equals("foofpong"))
              {
              c = services[i].connect();
              state = STATE_PLAYING;
              YOUR_SIDE=0;
              }
            }
           }
      }
    break;

  case UP:
    BOOST=1;
    if(racketPos[1]>racketMaxHeight && state==STATE_PLAYING|| state==STATE_SINGLEPLAY)
      racketAcc[1]=-30;
    else if(state==STATE_MENU);

    break;

  case DOWN:
    if(state==STATE_PLAYING || state==STATE_SINGLEPLAY)      
      racketAcc[1]=30;
    else if(state==STATE_BALL_SCORED)
      {
      c.writeInt(1);
      c.flush();
      state=STATE_PLAYING;
      ballAcc[1] = 9;
      }
    else if(state==STATE_MENU)
      {
      YOUR_SIDE = 1;
      state=STATE_SINGLEPLAY;
      ballAcc[1] = 9;
      }         
       
    break;
  }
  
 switch(key) {
  case '4':
    if(state==STATE_PLAYING || state==STATE_BALL_LOST ||state==STATE_BALL_SCORED|| state==STATE_SINGLEPLAY)
      racketAcc[0]=-20;
    else if(state==STATE_MENU)
      {
      state=STATE_HOSTING;
      bt.start("foofpong");
      }
    break;
  case '6':
    if(state==STATE_PLAYING || state==STATE_BALL_LOST || state==STATE_BALL_SCORED|| state==STATE_SINGLEPLAY)
      racketAcc[0]=20;
    else if(state==STATE_MENU)
      {
      state=STATE_CLIENT;
      ballPos[0] = -10;
      ballPos[1] = -10;
      ballAcc[1] = 0;
      bt.find();
      }
    else if(state==STATE_CLIENT)
      {
      if (services != null) {
          c = services[0].connect();
          state = STATE_SINGLEPLAY;
          YOUR_SIDE=0;
          }
      }
    break;

  case '2':
    BOOST=1;
    if(racketPos[1]>racketMaxHeight && state==STATE_PLAYING|| state==STATE_SINGLEPLAY)
      racketAcc[1]=-30;
    else if(state==STATE_MENU);

    break;

  case '8':
    if(state==STATE_PLAYING || state==STATE_SINGLEPLAY)      
      racketAcc[1]=30;
    else if(state==STATE_BALL_SCORED)
      {
      c.writeInt(1);
      c.flush();
      state=STATE_PLAYING;
      ballAcc[1] = 9;
      }
    else if(state==STATE_MENU)
      {
      YOUR_SIDE = 1;
      state=STATE_SINGLEPLAY;
      ballAcc[1] = 9;
      }
             
    break;
  }
}


public void keyReleased()
{
  racketAcc[0]=0;
  racketAcc[1]=racketGrav;
  racketVel[0]=0;
  racketVel[1]=0;
  BOOST=0;
}

public void libraryEvent(Object library, int event, Object data) {
  if (library == bt) {
    switch (event) {
    case Bluetooth.EVENT_DISCOVER_DEVICE:
      msg = "Found device at: " + ((Device) data).address + "...";
      break;
    case Bluetooth.EVENT_DISCOVER_DEVICE_COMPLETED:
      if (length((Device[]) data)>0)
        msg = "Found " + length((Device[]) data) + " devices, looking for game...";
      else msg = "Nothing found.";
      break;
    case Bluetooth.EVENT_DISCOVER_SERVICE:      
      msg = "Found game on " + ((Service[]) data)[0].device.address + ".\n Press -> to begin";
      break;
    case Bluetooth.EVENT_DISCOVER_SERVICE_COMPLETED:
      services = (Service[]) data;
      break;
    case Bluetooth.EVENT_CLIENT_CONNECTED:
      c = (Client) data;
      state = STATE_PLAYING;
      YOUR_SIDE = 1;
      break;
    }
  }
}

public void drawRacket()
{   
    racketPos[0]=racketNextPos[0];
    racketPos[1]=racketNextPos[1];
    drawStillRacket();
} 


public void drawStillRacket()
{
    if(BOOST==1) fill(100,100,0);
    else fill(100); 
    rect(racketPos[0],racketPos[1],racketWidth,racketHeight);
}

public void calcNextRacketPos()
{
  racketNextPos[1]=racketPos[1]+div(racketVel[1]+=racketAcc[1],gravityConstant);
  racketNextPos[0]=racketPos[0]+div(racketVel[0]+=racketAcc[0],gravityConstant);
}

public void calcRacketCollisions()
{
    
  if(racketNextPos[0]<0)
  {
    racketNextPos[0]=0;
    racketVel[0]=0;
  }
  else if(racketNextPos[0]+racketWidth>width)
  {
    racketNextPos[0]=width-racketWidth;
    racketVel[0]=0;
  }

  if(racketNextPos[1]<racketMaxHeight)
  {
    racketNextPos[1]=racketMaxHeight;
    racketVel[1]=0;
    racketAcc[1]=racketGrav;
    BOOST=0;
  }
  else if(racketNextPos[1]+racketHeight>height)
  {
    racketNextPos[1]=height-racketHeight;
    racketVel[1]=0;
  }
}


}